
/*
Copyright 2007-2011 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://gre/modules/XPCOMUtils.jsm");

function YaripAppStartupService() {
}
YaripAppStartupService.prototype = {
    classDescription: "Yet Another Remove It Permanently - App Startup Service",
    classID: Components.ID("{0f73e21b-fa4a-4e57-b991-200d6b0a52d0}"),
    contractID: "@yarip.mozdev.org/app-startup-service;1",
    _xpcom_categories: [{ category: "app-startup", service: true }],
    QueryInterface: XPCOMUtils.generateQI([
        Ci.nsISupports,
        Ci.nsIObserver,
        Ci.nsISupportsWeakReference
    ]),

    /*
     * nsIObserver
     */

    observe: function(subject, topic, data)
    {
        switch (topic) {
        case "app-startup":
            Cc["@mozilla.org/observer-service;1"].
                getService(Ci.nsIObserverService).
                addObserver(this, "profile-after-change", true);
            break;
        case "profile-after-change":
//            Cc["@mozilla.org/observer-service;1"].
//                getService(Ci.nsIObserverService).
//                addObserver(this, "quit-application", true);

            var FENNEC_ID = "{a23983c0-fd0e-11dc-95ff-0800200c9a66}";
            var appInfo = Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULAppInfo);
            var isMobile = appInfo.ID == FENNEC_ID;
//            if (!isMobile) {
                var yarip = Cu.import("resource://yarip/yarip.jsm", null).wrappedJSObject;
                Cc["@mozilla.org/observer-service;1"].
                    getService(Ci.nsIObserverService).
                    addObserver(yarip, "quit-application", true);
                yarip.isMobile = isMobile;
                yarip.init();
//            }

            Cu.import("resource://yarip/observer.jsm", null).wrappedJSObject.init();

            var webProgressListener = Cu.import("resource://yarip/webProgressListener.jsm", null).wrappedJSObject;
            Cc['@mozilla.org/docloaderservice;1'].
                getService(Ci.nsIWebProgress).
                addProgressListener(webProgressListener, Ci.nsIWebProgress.NOTIFY_STATE_DOCUMENT | Ci.nsIWebProgress.NOTIFY_STATE_REQUEST);
            break;
//        case "quit-application":
//            yarip.save();
//            break;
        }
    }
};

const NSGetFactory = XPCOMUtils.generateNSGetFactory([YaripAppStartupService]);

